// dump a bytestream in hex

#include <sys/types.h>
#include <ctype.h>
#include <iostream>

#define BYTESTR 16
#define BYTELEN  4

void hdump(register const char* bp, register u_int length) {

/* this could probably be more elegant, but it was ripped off from "hdump"
 * without much "how does it work" questions asked
 */
	long pos;
	size_t nread;
	register const u_char *sp;
	register u_int i;
	u_int flen = BYTELEN;

#ifdef DEBUG
	struct timeval tv;
	struct timezone tz;
	gettimeofday(&tv, &tz);
	s=(tv.tv_sec-8*60*60)%86400;
	debug("\n%02d:%02d:%02d.%06u\n", s/3600, (s%3600)/60, s%60, tv.tv_usec);
#endif
	if (length<0) {
		/* can't print if the data size is less that the offset */
		return;
	}

	pos = 0;
	while ( length > 0 ) {
		if (length < BYTESTR)
			nread = length;
		else
			nread = BYTESTR;
		sp = (u_char*)bp + pos;

#ifdef __cplusplus
		cout << "\n";
		cout.width(8);
		cout << pos;
		cout.width(0);
		cout << ":  ";
#else
		printf ( "\n%8ld:  ", pos );
#endif

		for ( i = 0; i < BYTESTR; i++ ) {
			if ( i < nread ) {
#ifdef __cplusplus
				cout.width(2);
				cout.fill('0');
				cout << hex << (u_int)sp[i];
				cout.fill(' ');
#else
				printf ( "%02x", sp[i] );
#endif
			} else
#ifdef __cplusplus
				cout << "  ";
#else
				printf ( "  " );
#endif
			if ( ( i % flen ) == ( flen - 1 ) )
#ifdef __cplusplus
				cout << " ";
#else
				printf ( " " ); 
#endif
		}

#ifdef __cplusplus
		cout << "  ";
#else
		printf ( "  " ); 
#endif
		for ( i = 0; i < BYTESTR; i++ ) {
			if ( i < nread ) {
				if ( isprint ( sp[i] ) )
#ifdef __cplusplus
					cout << sp[i];
#else
					printf ( "%c", sp[i] );
#endif
				else
#ifdef __cplusplus
					cout << ".";
#else
					printf ( "." );
#endif
			}
		}

		pos += nread;
		length -= nread;

	}
#ifdef __cplusplus
	cout << '\n';
#else
	printf("\n");
#endif

}
