/* functions for being able to be stateful about ICQ connections */

#include <sys/types.h>
#include <stdio.h>
#include <string.h>

#include "icq.h"

static char *rcs_id = "$Id: icq.C,v 1.2 1999/08/18 04:33:52 brian Exp $";

unsigned char icq_check_data5[256] = {
	0x59, 0x60, 0x37, 0x6B, 0x65, 0x62, 0x46, 0x48, 0x53, 0x61, 0x4C, 0x59, 0x60, 0x57, 0x5B, 0x3D,
	0x5E, 0x34, 0x6D, 0x36, 0x50, 0x3F, 0x6F, 0x67, 0x53, 0x61, 0x4C, 0x59, 0x40, 0x47, 0x63, 0x39,
	0x50, 0x5F, 0x5F, 0x3F, 0x6F, 0x47, 0x43, 0x69, 0x48, 0x33, 0x31, 0x64, 0x35, 0x5A, 0x4A, 0x42,
	0x56, 0x40, 0x67, 0x53, 0x41, 0x07, 0x6C, 0x49, 0x58, 0x3B, 0x4D, 0x46, 0x68, 0x43, 0x69, 0x48,
	0x33, 0x31, 0x44, 0x65, 0x62, 0x46, 0x48, 0x53, 0x41, 0x07, 0x6C, 0x69, 0x48, 0x33, 0x51, 0x54,
	0x5D, 0x4E, 0x6C, 0x49, 0x38, 0x4B, 0x55, 0x4A, 0x62, 0x46, 0x48, 0x33, 0x51, 0x34, 0x6D, 0x36,
	0x50, 0x5F, 0x5F, 0x5F, 0x3F, 0x6F, 0x47, 0x63, 0x59, 0x40, 0x67, 0x33, 0x31, 0x64, 0x35, 0x5A,
	0x6A, 0x52, 0x6E, 0x3C, 0x51, 0x34, 0x6D, 0x36, 0x50, 0x5F, 0x5F, 0x3F, 0x4F, 0x37, 0x4B, 0x35,
	0x5A, 0x4A, 0x62, 0x66, 0x58, 0x3B, 0x4D, 0x66, 0x58, 0x5B, 0x5D, 0x4E, 0x6C, 0x49, 0x58, 0x3B,
	0x4D, 0x66, 0x58, 0x3B, 0x4D, 0x46, 0x48, 0x53, 0x61, 0x4C, 0x59, 0x40, 0x67, 0x33, 0x31, 0x64,
	0x55, 0x6A, 0x32, 0x3E, 0x44, 0x45, 0x52, 0x6E, 0x3C, 0x31, 0x64, 0x55, 0x6A, 0x52, 0x4E, 0x6C,
	0x69, 0x48, 0x53, 0x61, 0x4C, 0x39, 0x30, 0x6F, 0x47, 0x63, 0x59, 0x60, 0x57, 0x5B, 0x3D, 0x3E,
	0x64, 0x35, 0x3A, 0x3A, 0x5A, 0x6A, 0x52, 0x4E, 0x6C, 0x69, 0x48, 0x53, 0x61, 0x6C, 0x49, 0x58,
	0x3B, 0x4D, 0x46, 0x68, 0x63, 0x39, 0x50, 0x5F, 0x5F, 0x3F, 0x6F, 0x67, 0x53, 0x41, 0x25, 0x41,
	0x3C, 0x51, 0x54, 0x3D, 0x5E, 0x54, 0x5D, 0x4E, 0x4C, 0x39, 0x50, 0x5F, 0x5F, 0x5F, 0x3F, 0x6F,
	0x47, 0x43, 0x69, 0x48, 0x33, 0x51, 0x54, 0x5D, 0x6E, 0x3C, 0x31, 0x64, 0x35, 0x5A, 0x00, 0x00
};

WORD
ICQVersion(ICQMsg *pICQMsg)	{
	return *((WORD *)((unsigned char *)pICQMsg->pData));
}

WORD
ICQCommand(ICQMsg *pICQMsg)	{
	if (!pICQMsg->bServerMsg) 
		if (ICQVersion(pICQMsg) == 4)
			return *((WORD *)((unsigned char *)pICQMsg->pDecryptedData+6));
		else if (ICQVersion(pICQMsg) == 5)
			return *((WORD *)((unsigned char *)pICQMsg->pDecryptedData+14));
		else
			return 0;
	else
		return *((WORD *)((unsigned char *)pICQMsg->pDecryptedData+7));
}

void
GetCommandName(WORD nCommand, char *szBuffer) {

	switch (nCommand) {

		case ICQ_ACK:
			strcpy(szBuffer, "ACK");
			break;
		case ICQ_SEND_MESSAGE:
			strcpy(szBuffer, "SEND_MESSAGE");
			break;
		case ICQ_LOGIN:
			strcpy(szBuffer, "LOGIN");
			break;
		case ICQ_CONTACT_LIST:
			strcpy(szBuffer, "CONTACT_LIST");
			break;
		case ICQ_SEARCH_UIN:
			strcpy(szBuffer, "SEARCH_UIN");
			break;
		case ICQ_SEARCH_USER:
			strcpy(szBuffer, "SEARCH_USER");
			break;
		case ICQ_KEEP_ALIVE:
			strcpy(szBuffer, "KEEP_ALIVE");
			break;
		case ICQ_SEND_TEXT_CODE:
			strcpy(szBuffer, "SEND_TEXT_CODE");
			break;
		case ICQ_LOGIN_1:
			strcpy(szBuffer, "LOGIN_1");
			break;
		case ICQ_INFO_REQ:
			strcpy(szBuffer, "INFO_REQ");
			break;
		case ICQ_EXT_INFO_REQ:
			strcpy(szBuffer, "EXT_INFO_REQ");
			break;
		case ICQ_CHANGE_PASSWORD:
			strcpy(szBuffer, "CHANGE_PASSWORD");
			break;
		case ICQ_STATUS_CHANGE:
			strcpy(szBuffer, "STATUS_CHANGE");
			break;
		case ICQ_LOGIN_2:
			strcpy(szBuffer, "LOGIN_2");
			break;

		case ICQ_UPDATE_INFO:
			strcpy(szBuffer, "UPDATE_INFO");
			break;
		case ICQ_UPDATE_EXT_INFO:
			strcpy(szBuffer, "UPDATE_EXT_INFO");
			break;
		case ICQ_ADD_TO_LIST:
			strcpy(szBuffer, "ADD_TO_LIST");
			break;
		case ICQ_REQ_ADD_TO_LIST:
			strcpy(szBuffer, "REQ_ADD_TO_LIST");
			break;
		case ICQ_QUERY_SERVERS:
			strcpy(szBuffer, "QUERY_SERVERS");
			break;
		case ICQ_QUERY_ADDONS:
			strcpy(szBuffer, "QUERY_ADDONS");
			break;
		case ICQ_NEW_USER_1	:
			strcpy(szBuffer, "NEW_USER_1");
			break;
		case ICQ_NEW_USER_REG:
			strcpy(szBuffer, "NEW_USER_REG");
			break;
		case ICQ_NEW_USER_INFO:
			strcpy(szBuffer, "NEW_USER_INFO");
			break;
		case ICQ_CMD_X1:
			strcpy(szBuffer, "CMD_X1");
			break;
		//case ICQ_MSG_TO_NEW_USER:					// Hey! this message number is used
		//	strcpy(szBuffer, "MSG_TO_NEW_USER");	// Twice. Has anyone else realised this?
		//	break;


		case ICQ_LOGIN_REPLY:
			strcpy(szBuffer, "LOGIN_REPLY");
			break;
		case ICQ_USER_ONLINE:
			strcpy(szBuffer, "USER_ONLINE");
			break;
		case ICQ_USER_OFFLINE:
			strcpy(szBuffer, "USER_OFFLINE");
			break;
		case ICQ_USER_FOUND:
			strcpy(szBuffer, "USER_FOUND");
			break;
		case ICQ_RECEIVE_MESSAGE:
			strcpy(szBuffer, "RECEIVE_MESSAGE");
			break;
		case ICQ_END_OF_SEARCH:
			strcpy(szBuffer, "END_OF_SEARCH");
			break;
		case ICQ_INFO_REPLY:
			strcpy(szBuffer, "INFO_REPLY");
			break;
		case ICQ_EXT_INFO_REPLY:
			strcpy(szBuffer, "EXT_INFO_REPLY");
			break;
		case ICQ_STATUS_UPDATE:
			strcpy(szBuffer, "STATUS_UPDATE");
			break;
		case ICQ_MULTIPLE_PACKET:
			strcpy(szBuffer, "MULTIPLE_PACKET");
			break;
		case ICQ_INSTANT_MESSAGE:
			strcpy(szBuffer, "INSTANT_MESSAGE");
			break;

		case ICQ_REPLY_X1:
			strcpy(szBuffer, "REPLY_X1");
			break;
		case ICQ_REPLY_X2:
			strcpy(szBuffer, "REPLY_X2");
			break;
		case ICQ_UPDATE_REPLY:
			strcpy(szBuffer, "UPDATE_REPLY");
			break;
		case ICQ_UPDATE_EXT_REPLY:
			strcpy(szBuffer, "UPDATE_EXT_REPLY");
			break;
		case ICQ_NEW_USER_UIN:
			strcpy(szBuffer, "NEW_USER_UIN");
			break;
		case ICQ_NEW_USER_REPLY:
			strcpy(szBuffer, "NEW_USER_REPLY");
			break;
		case ICQ_QUERY_REPLY:
			strcpy(szBuffer, "QUERY_REPLY");
			break;
		case ICQ_SYSTEM_MESSAGE:
			strcpy(szBuffer, "SYSTEM_MESSAGE");
			break;
		case ICQ_CMD_INVIS_LIST:
			strcpy(szBuffer, "ICQ_CMD_INVIS_LIST");
			break;
		case ICQ_CMD_VIS_LIST:
			strcpy(szBuffer, "ICQ_CMD_VIS_LIST");
			break;
		case ICQ_CMD_META_USER:
			strcpy(szBuffer, "ICQ_CMD_META_USER");
			break;

		default:
			sprintf(szBuffer, "Unknown: (%04x)", nCommand);
	}
}

DWORD
ICQUIN(ICQMsg *pICQMsg) {
	if (!pICQMsg->bServerMsg) 
		if (ICQVersion(pICQMsg) == 4)
			return *((DWORD *)((unsigned char *)pICQMsg->pDecryptedData+12));
		else if (ICQVersion(pICQMsg) == 5)
			return *((DWORD *)((unsigned char *)pICQMsg->pDecryptedData+6));
		else
			return 0;
	else 
		return *((DWORD *)((unsigned char *)pICQMsg->pDecryptedData+13));
}

WORD
ICQSeqNum1(ICQMsg *pICQMsg)	{
	if (!pICQMsg->bServerMsg) 
		if (ICQVersion(pICQMsg) == 4)
			return *((WORD *)((unsigned char *)pICQMsg->pDecryptedData+8));
		else if (ICQVersion(pICQMsg) == 5)
			return *((WORD *)((unsigned char *)pICQMsg->pDecryptedData+16));
		else
			return 0;

	else
		return *((WORD *)((unsigned char *)pICQMsg->pDecryptedData+9));
}

WORD
ICQSeqNum2(ICQMsg *pICQMsg)	{
	if (!pICQMsg->bServerMsg) 
		if (ICQVersion(pICQMsg) == 4)
			return *((WORD *)((unsigned char *)pICQMsg->pDecryptedData+10));
		else if (ICQVersion(pICQMsg) == 5)
			return *((WORD *)((unsigned char *)pICQMsg->pDecryptedData+18));
		else
			return 0;
	else
		return *((WORD *)((unsigned char *)pICQMsg->pDecryptedData+11));
}

DWORD
ICQCheckCode(ICQMsg *pICQMsg) {
	if (!pICQMsg->bServerMsg) 
		if (ICQVersion(pICQMsg) == 4)
			return *((DWORD *)((unsigned char *)pICQMsg->pData+20));
		else if (ICQVersion(pICQMsg) == 5)
			return *((DWORD *)((unsigned char *)pICQMsg->pData+20));
		else
			return 0;
	else
		return *((DWORD *)((unsigned char *)pICQMsg->pData+17));
}

DWORD
GetKey(ICQMsg *pICQMsg) {
	DWORD key = 0, check;
		DWORD A1,A2,A3,A4,A5;

	if (ICQVersion(pICQMsg) == 5) {
		// Unscramble bits

		check = ICQCheckCode(pICQMsg);

		A1 = check & 0x0001F000;
		A2 = check & 0x07C007C0;
		A3 = check & 0x003E0001;
		A4 = check & 0xF8000000;
		A5 = check & 0x0000083E;

		A1 = A1 >> 0x0C;
		A2 = A2 >> 0x01;
		A3 = A3 << 0x0A;
		A4 = A4 >> 0x10;
		A5 = A5 << 0x0F;

		check = A1 + A2 + A3 + A4 + A5;

		key = 0x68656C6C * pICQMsg->nMsgLen;
		key += check;

	} else if (ICQVersion(pICQMsg) == 4) {
		check = ICQCheckCode(pICQMsg) ^ 0x00ff00ff;

		/*A1 = check & 0x0001F000;
		A2 = check & 0x07C007C0;
		A3 = check & 0x003E0001;
		A4 = check & 0xF8000000;
		A5 = check & 0x0000083E;

		A1 = A1 >> 0x0C;
		A2 = A2 >> 0x01;
		A3 = A3 << 0x0A;
		A4 = A4 >> 0x10;
		A5 = A5 << 0x0F;

		check = A1 + A2 + A3 + A4 + A5;*/

		key = 0x66756B65 * pICQMsg->nMsgLen;
		key += check;
	} 
	return key;
}

void
DecryptPacket(ICQMsg *pICQMsg) {
	DWORD nCode = 0, nData, key;

	int n, pos, t;

	// Skip if we've already decrpyted this message.
	// I was going to call this function whenever
	// decrypted data needed to be read, so this stopped
	// from decrypting the message more than once.
	// Not reall needed now, but it may come in useful later/
	if (pICQMsg->bDecrypted == TRUE) return;
	pICQMsg->bDecrypted = TRUE;

	// Copy pData to pDecryptedData buffer.
	// If this is a Server message, we can leave after this bit
	memcpy(pICQMsg->pDecryptedData, pICQMsg->pData, pICQMsg->nMsgLen);

	// Don't decrypt Server msgs or messages that aren't v4 or v5
	if (pICQMsg->bServerMsg ||
		(ICQVersion(pICQMsg) != 4 &&
		 ICQVersion(pICQMsg) != 5) ) return;

	// We need to get the key for this message. 
	// The key is calculated above (it involves unscrambing
	// the CheckCode's bits, and adding that value to
	// the packet length multiplied by a magic number.
	key = GetKey(pICQMsg);


	if (ICQVersion(pICQMsg) == 4) {
		int count, i;
		count =(pICQMsg->nMsgLen + 3) / 4;
		count+=3;
		count/=4;
		count = 3;
 
		for(i=0; i<count; i++) {
			t = (i*4) % 256;
			nCode = key + icq_check_data5[t*4];

			if(i!=4) {	// checksum is not encrypted
				nData = *(DWORD *)(&pICQMsg->pDecryptedData[i*4]);

				nData ^= nCode;

				*(DWORD *)(&pICQMsg->pDecryptedData[i*4]) = nData;
			}
		}
		// Replace first two bytes...
		*(WORD *)(pICQMsg->pDecryptedData) = 4;

	}
	// This routine doesn't actually work right - 
	// it splatters the last few bytes of the buffer.
	// Will be fixed soon.
	// Basically loops through each DWORD in the buffer,
	// XORing each with nCode (which is the key value
	// plus a value in the magic check table.

	if (ICQVersion(pICQMsg) == 5) {
		n = (pICQMsg->nMsgLen + 3);

		pos = 0x0A;					// Start at position 10

		while (pos < n) {
			t = pos % 256;		// There are 256 values in the table...

			nCode = key + icq_check_data5[t];

			nData = *(DWORD *)(&pICQMsg->pDecryptedData[pos]);

			nData ^= nCode;				// XOR with code

			*(DWORD *)(&pICQMsg->pDecryptedData[pos]) = nData;

			pos += 4;
		}
	}

}

void
IPToStr(DWORD nIP, char *szBuffer) {
	sprintf(szBuffer, "%d.%d.%d.%d",
		nIP&0xFF,
		(nIP>>8)&0xFF,
		(nIP>>16)&0xFF,
		(nIP>>24)&0xFF);
}

void
ProcessLogin(ICQMsg *pICQMsg) {

	char szBuffer[16];			// Used to get text representation of IP address in

	// I'll convert all these nasty 24+x+y+.. bits into something a bit less untidy...
	DWORD nPort  = *(DWORD *)((pICQMsg->pDecryptedData)+24+4);
	WORD  nLength= *(WORD  *)((pICQMsg->pDecryptedData)+24+8);
	DWORD nIP    = *(DWORD *)((pICQMsg->pDecryptedData)+24+10+nLength+4);

	IPToStr(nIP, szBuffer);

	// Display password etc...
	sprintf(pICQMsg->szExtraInfo, "UID: %d, " \
					  "IP:Port: %s:%d, " \
					  "Password: %s (%d chars)",
					   
					  ICQUIN(pICQMsg),
					  szBuffer, nPort, 
					  (pICQMsg->pDecryptedData)+24+10, nLength);

}

void
ProcessTextCode(ICQMsg *pICQMsg) {
	WORD nMsgSize = *(WORD *)((pICQMsg->pDecryptedData)+24);
	WORD nUnknown = *(WORD *)((pICQMsg->pDecryptedData)+24+2+nMsgSize);

	// I print out the unknown at the end of the message. Let me know if you get anything but 5.
	// Just a thought - it's probably info specific to the specified message
	sprintf(pICQMsg->szExtraInfo, "'%s' (Unknown = %d)",
				(pICQMsg->pDecryptedData)+24+2,
				nUnknown);
}

void ProcessStatusUpdate(ICQMsg *pICQMsg) {

	DWORD UIN = *(WORD *)((pICQMsg->pDecryptedData)+21);
	DWORD Status = *(WORD *)((pICQMsg->pDecryptedData)+25);
	
	switch (Status) {
		case 0x0:	
			sprintf(pICQMsg->szExtraInfo, "Online: %d", UIN);
			break;
		case 0x1:	
			sprintf(pICQMsg->szExtraInfo, "Away: %d", UIN);
			break;
		case 0x13:	
			sprintf(pICQMsg->szExtraInfo, "DND: %d", UIN);
			break;
		case 0x100:	
			sprintf(pICQMsg->szExtraInfo, "Invisible: %d", UIN);
			break;
		case 0x10:	
			sprintf(pICQMsg->szExtraInfo, "Occupied: %d", UIN);
			break;
		case 0x4:	
			sprintf(pICQMsg->szExtraInfo, "N/A: %d", UIN);
			break;
		case 0x20:	
			sprintf(pICQMsg->szExtraInfo, "Free Chat: %d", UIN);
			break;
		default:
			sprintf(pICQMsg->szExtraInfo, "Unknown (%x)", Status);
		
	}

}

void
ProcessStatusChange(ICQMsg *pICQMsg) {

	DWORD Status = *(WORD *)((pICQMsg->pDecryptedData)+24);
	
	switch (Status) {
		case 0x0:	
			sprintf(pICQMsg->szExtraInfo, "Online");
			break;
		case 0x1:	
			sprintf(pICQMsg->szExtraInfo, "Away");
			break;
		case 0x13:	
			sprintf(pICQMsg->szExtraInfo, "DND");
			break;
		case 0x100:	
			sprintf(pICQMsg->szExtraInfo, "Invisible");
			break;
		case 0x10:	
			sprintf(pICQMsg->szExtraInfo, "Occupied");
			break;
		case 0x4:	
			sprintf(pICQMsg->szExtraInfo, "N/A");
			break;
		case 0x20:	
			sprintf(pICQMsg->szExtraInfo, "Free Chat");
			break;
		default:
			sprintf(pICQMsg->szExtraInfo, "Unknown (%x)", Status);
		
	}

}

void
ProcessAck(ICQMsg *pICQMsg) {

	// Display seqnums
	sprintf(pICQMsg->szExtraInfo, "SeqNums: %d,%d",
					  ICQSeqNum1(pICQMsg),
					  ICQSeqNum2(pICQMsg));

}

void
ProcessContactList(ICQMsg *pICQMsg) {
	BYTE nNumContacts  = *(BYTE *)((pICQMsg->pDecryptedData)+24);
	DWORD nUIN;
	int i;
	char szBuffer[2048];

	strcpy(pICQMsg->szExtraInfo, "");

	// Get UIN for each person in the list
	for (i = 0; i < nNumContacts; i++) {

		// This is a bit hairy- we shoould really check that we're not
		// trying to access past the end of the message buffer..
		nUIN = *(DWORD *)((pICQMsg->pDecryptedData)+24+1+i*4);

		// Print decimal representation of their UIN to buffer and concatenate...
		sprintf(szBuffer, "%d ", nUIN);
		strcat(pICQMsg->szExtraInfo, szBuffer);
	}
}

void
ProcessMultiple(ICQMsg *pICQMsg, void *fn(ICQMsg *)) {
	int n, offset=21;
	BYTE nNumPackets=*(BYTE *)((pICQMsg->pDecryptedData)+offset);
	offset++;
	for (n=0; n<nNumPackets; n++) {
		ICQMsg icqm, *pICQsMsg=&icqm;
		WORD nPacketSize=*(BYTE *)((pICQMsg->pDecryptedData)+offset);
		offset+=2;

		pICQsMsg->pData=pICQMsg->pDecryptedData+offset;

		pICQsMsg->bDecrypted=TRUE;
		pICQsMsg->bServerMsg=pICQMsg->bServerMsg;
		pICQsMsg->pNextMsg=NULL;
		pICQsMsg->pPrevMsg=NULL;
		pICQsMsg->nMsgLen=nPacketSize;
		pICQsMsg->pDecryptedData=pICQMsg->pDecryptedData+offset;
		/* Don't need to do this
		DecryptPacket(pICQMsg);
		*/
		fn(pICQsMsg);

		offset+=nPacketSize;
	}

}

void ProcessUserOnline(ICQMsg *pICQMsg) {
	char IP[16], rIP[16];
	DWORD UIN, Port;
	
	UIN=*(DWORD *)((pICQMsg->pDecryptedData)+21);
	IPToStr(*(DWORD *)((pICQMsg->pDecryptedData)+25), IP);
	Port=*(DWORD *)((pICQMsg->pDecryptedData)+29);
	IPToStr(*(DWORD *)((pICQMsg->pDecryptedData)+33), rIP);

	sprintf(pICQMsg->szExtraInfo, "%d@%s:%u(%s)", UIN, IP, Port, rIP);
}
